/*************************************************
* ZeusCMD - OpenGL Tutorial 10 : Transformations *
* By Grant James (ZEUS)                          *
* http://www.zeuscmd.com                         *
*************************************************/
#include <windows.h>
#include "glutil.h"

OpenGL *opengl;

float xrot = 0.0f;
float yrot = 0.0f;

bool init()
{
	glClearColor(0.93f, 0.93f, 0.93f, 0.0f);

	return true;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);

	// TRIANGLE
	glPushMatrix();

		glTranslatef(0.25f, 0.5f, 0.0f);

		glScalef(0.5f, 0.5f, 0.5f);
		glRotatef(xrot, 1.0f, 0.0f, 0.0f);

		glBegin(GL_TRIANGLES);
			glColor3f(1.0f, 0.0f, 0.0f);
			glVertex3f(-0.25f, -0.25f, 0.0f);
			glColor3f(0.0f, 1.0f, 0.0f);
			glVertex3f( 0.25f, -0.25f, 0.0f);
			glColor3f(0.0f, 0.0f, 1.0f);
			glVertex3f(-0.25f,  0.25f, 0.0f);
		glEnd();

	glPopMatrix();

	// SQUARE
	glPushMatrix();

		glTranslatef(0.75f, 0.5f ,0.0f);
		glScalef(0.5f, 0.5f, 0.5f);
		glRotatef(yrot, 0.0f, 1.0f, 0.0f);

		glBegin(GL_QUADS);
			glColor3f(0.0f, 0.0f, 1.0f);
			glVertex2f(-0.25f, -0.25f);
			glVertex2f( 0.25f, -0.25f);
			glVertex2f( 0.25f,  0.25f);
			glVertex2f(-0.25f,  0.25f);
		glEnd();

	glPopMatrix();
		
	glFlush();
}

void resize(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, w, h);
	gluOrtho2D(0.0, 1.0, 0.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void idle()
{
	xrot += 0.2f;
	yrot += 0.3f;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	opengl = OpenGL::create();

	opengl->setInitFunc(init);
	opengl->setDisplayFunc(display);
	opengl->setIdleFunc(idle);
	opengl->setResizeFunc(resize);

	if (!opengl->initGL("10 - Transformations", 500, 500, false, 32))
		return 1;

	opengl->runMessageLoop();

	return 0;
}
